#!/bin/bash

SCRIPTDIR="$PWD"

echo -n 'Reading SVN log...'
php generateNotesReadSVNLog.php < svnlog.xml > svnlog.ser || exit 1
echo ' done.'

for x in "$@" ; do
	cd "$SCRIPTDIR" || exit 1
	[[ -d "$x" ]] || continue

	echo "Processing $x..." >&2
	cd "$x" || exit 1

	if git show-ref -q --verify refs/notes/commits; then
		echo 'Commit notes already exist.' >&2
		echo >&2
		continue
	fi

	if [[ -e "$SCRIPTDIR/gitlog.tsv" ]]; then
		rm -rf "$SCRIPTDIR/gitlog.tsv" || exit 1
	fi

	echo -n 'Generating Git log...' >&2
	git log --all --format='%H%x09%ae%x09%at' > "$SCRIPTDIR/gitlog.tsv" || continue

	if grep -q '@users.mediawiki.org' "$SCRIPTDIR/gitlog.tsv"; then
		echo ' done.' >&2
		(cd "$SCRIPTDIR" && php generateNotes.php < config.json) | git fast-import --quiet || continue
	else
		echo ' no SVN commits found.' >&2
	fi

	echo
done

rm "$SCRIPTDIR/gitlog.tsv"
